[inherit('pbdbdir:pbdb')]
program itest(input,output);

type
   r = record
          iv : integer;
          sv : varying [50] of char;
       end;

var
   db : db_ptr;
   it : cursor_ptr;
   v, v2 : r;
   k, stat, dummy : integer;

begin
   db := db_open('itest.db');
   (* put *)
   v.iv := 123;
   v.sv := 'ABC';
   db_ik_put(db, 1, iaddress(v), size(v));
   v.iv := 456;
   v.sv := 'DEF';
   db_ik_put(db, 2, iaddress(v), size(v));
   (* get *)
   db_ik_get(db, 1, iaddress(v2), size(v2), dummy);
   writeln(v2.iv:1,' ', v2.sv);
   db_ik_get(db, 2, iaddress(v2), size(v2), dummy);
   writeln(v2.iv:1,' ', v2.sv);
   (* list all *)
   it := db_cursor_open(db);
   while db_cursor_ik_next(it, k, iaddress(v2), size(v2), dummy) = 0 do begin
      writeln(k:1, ' ', v2.iv:1,' ', v2.sv);
   end;
   (* list from k1*)
   k := 1;
   stat := db_cursor_ik_find(it, k, iaddress(v2), size(v2), dummy);
   while stat = 0 do begin
      writeln(k:1, ' ', v2.iv:1,' ', v2.sv);
      stat := db_cursor_ik_next(it, k, iaddress(v2), size(v2), dummy);
   end;
   (* list from k2*)
   k := 2;
   stat := db_cursor_ik_find(it, k, iaddress(v2), size(v2), dummy);
   while stat = 0 do begin
      writeln(k:1, ' ', v2.iv:1,' ', v2.sv);
      stat := db_cursor_ik_next(it, k, iaddress(v2), size(v2), dummy);
   end;
   (* delete *)
   k := 1;
   db_ik_delete(db, k);
   it := db_cursor_open(db);
   while db_cursor_ik_next(it, k, iaddress(v2), size(v2), dummy) = 0 do begin
      writeln(k:1, ' ', v2.iv:1,' ', v2.sv);
   end;
   db_close(db);
end.
